## net.sf.saxon.instruct
Class Attribute

    java.lang.Object
      |
      +--net.sf.saxon.expr.ComputedExpression
            |
            +--net.sf.saxon.instruct.Instruction
                  |
                  +--net.sf.saxon.instruct.InstructionWithChildren
                        |
                        +--net.sf.saxon.instruct.SimpleNodeConstructor
                              |
                              +--net.sf.saxon.instruct.Attribute

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public final class Attribute
extends SimpleNodeConstructor

An instruction derived from an xsl:attribute element in stylesheet, or from an attribute constructor in XQuery

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`select, separator`

Fields inherited from class net.sf.saxon.instruct.InstructionWithChildren
`children`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Attribute(Expression attributeName, Expression namespace, NamespaceResolver nsContext, int validationAction, SimpleType schemaType, int annotation)` Construct an Attribute instruction

Method Summary
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Display this instruction as an expression, for diagnostics
`protected int` `evaluateNameCode(XPathContext context)`
`int` `getCardinality()` Determine the static cardinality of the expression.
`int` `getDependencies()` Determine which aspects of the context the expression depends on.
`int` `getInstructionNameCode()` Get the name of this instruction
`ItemType` `getItemType()` Get the item type of the items returned by evaluating this instruction
`java.util.Iterator` `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`TailCall` `processLeavingTail(XPathContext context)` Process this instruction
`protected void` `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
`void` `setRejectDuplicates()` Indicate that two attributes with the same name are not acceptable.
`Expression` `simplify(StaticContext env)` Simplify an expression.
`void` `typeCheck(StaticContext env, ItemType contextItemType)`

Methods inherited from class net.sf.saxon.instruct.SimpleNodeConstructor
`analyze, checkContent, evaluateItem, expandChildren, iterate, setSelect, setSeparator`

Methods inherited from class net.sf.saxon.instruct.InstructionWithChildren
`displayChildren, getChildren, processChildren, processChildrenLeavingTail, setChildren`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, getImplementationMethod, getInstructionInfo, getSourceLocator, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, computeDependencies, computeStaticProperties, dynamicError, dynamicError, getColumnNumber, getConstructType, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### Attribute

    public Attribute(Expression attributeName,
                     Expression namespace,
                     NamespaceResolver nsContext,
                     int validationAction,
                     SimpleType schemaType,
                     int annotation)

  Construct an Attribute instruction

Parameters:
  `attributeName` - An expression to calculate the attribute name
  `namespace` - An expression to calculate the attribute namespace
  `nsContext` - a NamespaceContext object containing the static namespace context of the stylesheet instruction
  `annotation` - Integer code identifying the type named in the `type` attribute of the instruction - zero if the attribute was not present

Method Detail

### setRejectDuplicates

    public void setRejectDuplicates()

  Indicate that two attributes with the same name are not acceptable. (This option is set in XQuery, but not in XSLT)

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### getItemType

    public ItemType getItemType()

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Instruction`
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `ComputedExpression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `ComputedExpression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Description copied from class: `InstructionWithChildren`
  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `SimpleNodeConstructor`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public void typeCheck(StaticContext env,
                          ItemType contextItemType)
                   throws XPathException

  Specified by:
    `typeCheck` in class `SimpleNodeConstructor`
    `XPathException`

### getDependencies

    public int getDependencies()

  Description copied from class: `ComputedExpression`
  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.

  Specified by:
    `getDependencies` in interface `Expression`
  Overrides:
    `getDependencies` in class `ComputedExpression`
  Returns:
    a set of bit-significant flags identifying the dependencies of the expression

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Description copied from class: `InstructionWithChildren`
  Get the immediate sub-expressions of this expression.

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `SimpleNodeConstructor`
  Returns:
    an iterator containing the sub-expressions of this expression

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Overrides:
    `promoteInst` in class `SimpleNodeConstructor`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Process this instruction

  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic context of the transformation
  Returns:
    a TailCall to be executed by the caller, always null for this instruction
    `XPathException`

### evaluateNameCode

    protected int evaluateNameCode(XPathContext context)
                            throws XPathException,
                                   XPathException

  Overrides:
    `evaluateNameCode` in class `SimpleNodeConstructor`
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Display this instruction as an expression, for diagnostics

  Specified by:
    `display` in interface `Expression`
  Overrides:
    `display` in class `SimpleNodeConstructor`
  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination